package com.example.practicefinal

import android.content.Context
import android.media.MediaPlayer
import android.os.Bundle
import android.os.CountDownTimer
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.Button
import android.widget.EditText
import android.widget.TextView
import android.widget.Toast
import androidx.fragment.app.Fragment
import kotlinx.android.synthetic.main.fragment_egg_timer.*

public class FragmentEggTimer: Fragment(){

    // fragment version on onCreat
    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View?{
        //use the "inflater" to make a View
        val myView: View = inflater.inflate(R.layout.fragment_egg_timer, container, false)

        var mySavedTime: Long? = 33

        val btnStart = myView.findViewById<Button>(R.id.btnStart)
        val etTime = myView.findViewById<EditText>(R.id.edTime)
        val tvShowTime = myView.findViewById<TextView>(R.id.tvShowTime)
        val btnSaveTime = myView.findViewById<Button>(R.id.btnSaveTime)

        val shared_pref = this.activity?.getSharedPreferences("SP_DEMO", Context.MODE_PRIVATE)
        val shared_pref_editor = shared_pref?.edit()

        mySavedTime = shared_pref?.getLong("SAVED_TIME",33)

        etTime.setText(mySavedTime.toString())

        btnStart.setOnClickListener{

            Toast.makeText(myView.context,"HI", Toast.LENGTH_SHORT).show()
            btnStart.isEnabled = false

            var myTime:Long = etTime.text.toString().toLong()
            myTime=myTime
            val myTimer = object : CountDownTimer(myTime*1000, 1000) {

                //repeating event -- get new random number & display corresponding image
                override fun onTick(l: Long) {
                    myTime-=1
                    tvShowTime.text = ""+myTime
                }//end onTick

                // ending event -- set class-level variable to "last" random number
                override fun onFinish() {
                    btnStart.isEnabled = true
                    val mp = MediaPlayer.create(myView.context, R.raw.submarine_diving)
                    mp.start()

                }//end onFinish
            } //end CountDownTimer
            // you need to start the timer or nothing happens
            myTimer.start()
        }


        btnSaveTime.setOnClickListener {
            var myTime:Long = etTime.text.toString().toLong()
            shared_pref_editor?.putLong("SAVED_TIME",myTime)

            shared_pref_editor?.apply()  //IMPORTANT!!!!
        }

        //return the View once you have coded its interactivity
        return myView
    }//end onCreate
}//end FragmentEggTimer