package com.example.practicefinal

import android.content.Context
import android.hardware.SensorEventListener
import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.Button
import android.widget.Toast
import androidx.fragment.app.Fragment
import android.content.Context.SENSOR_SERVICE
import android.hardware.Sensor
import android.hardware.SensorEvent
import android.hardware.SensorManager
import android.util.Log
import android.widget.EditText
import android.widget.TextView
import kotlinx.android.synthetic.main.fragment_press_adjust.*


public class FragmentPressAdjust: Fragment()  {

    private lateinit var sensorManager: SensorManager
    private lateinit var my_pressure_sensor: Sensor
    private lateinit var tvPressure: TextView
    var psi:Double =0.0

    companion object{
        fun newInstance():FragmentPressAdjust{
            return newInstance()
        }
    }

    // fragment version on onCreat
    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View?{
        //use the "inflater" to make a View
        val myView:View= inflater.inflate(R.layout.fragment_press_adjust, container, false)

        tvPressure = myView.findViewById<TextView>(R.id.tvPressure)
        val etRecipeTime = myView.findViewById<EditText>(R.id.etRecipeTime)
        val tvAdjustedTime = myView.findViewById<TextView>(R.id.tvAdjustedTime)

        sensorManager = activity!!.getSystemService(Context.SENSOR_SERVICE) as SensorManager
        my_pressure_sensor = sensorManager.getDefaultSensor(Sensor.TYPE_PRESSURE)
        sensorManager!!.registerListener(myListener, my_pressure_sensor, SensorManager.SENSOR_DELAY_NORMAL)

        val btnAdjust = myView.findViewById<Button>(R.id.btnAdjust)

        btnAdjust.setOnClickListener{

            var factor = 0.101*(14.7-psi)
            var recipe_time = etRecipeTime.text.toString().toDouble()
            var new_time = recipe_time*(1+factor)

            tvAdjustedTime.setText(String.format("Pressure-adjusted time: \t\t%.2f seconds",new_time))


           // Toast.makeText(myView.context,"HI",Toast.LENGTH_SHORT).show()
        }





        //return the View once you have coded its interactivity
        return myView
    }//end onCreate


    private val myListener = object : SensorEventListener {
        override fun onSensorChanged(event: SensorEvent) {
            //Toast.makeText(myView.context,"press",Toast.LENGTH_SHORT).show()
            when (event?.sensor?.type) {
                Sensor.TYPE_PRESSURE -> {
                    psi = event.values[0]*0.0145038

                    tvPressure.setText(String.format("Pressure: \t\t%.2f psi",psi))

                }
            }
            //Log.d("MY_APP", event.toString())
        }

        override fun onAccuracyChanged(sensor: Sensor, accuracy: Int) {
            //Log.d("MY_APP", "$sensor - $accuracy")
        }
    }


}//end FragmentPressAdjust